// USBPIO24TestDlg.cpp : t@C
//
//
//	Ver 1.0		2008/09/23
//
#include "stdafx.h"
#include "USBPIO24Test.h"
#include "USBPIO24TestDlg.h"
#include "mchusb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
public:
	static bool USBPIO24_Open(void);
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CUSBPIO24TestDlg _CAO




CUSBPIO24TestDlg::CUSBPIO24TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBPIO24TestDlg::IDD, pParent)
	, m_iBoardNo(0)
	, m_iMode(0)
	, m_bPortOpen(FALSE)
	, m_sDirectionA(_T("FF"))
	, m_sDirectionB(_T("FF"))
	, m_sDirectionC(_T("FF"))
	, m_sOutputA(_T("00"))
	, m_sOutputB(_T("00"))
	, m_sOutputC(_T("00"))
	, m_sInputA(_T("00"))
	, m_sInputB(_T("00"))
	, m_sInputC(_T("00"))
	, m_iStartAddress(0)
	, m_sStnMessage(_T("Welcome to USBPIO-24"))
	, m_sCommand(_T(""))
	, m_sReply(_T(""))
	, m_bApplyCheckSum(FALSE)
	, m_bNoReply(FALSE)
	, m_iAdcVal(0)
	, m_iAdcCh(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBPIO24TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO_MODE1, m_iMode);
	DDX_CBIndex(pDX, IDC_COMBO_BOARD_NO, m_iBoardNo);
	DDX_Text(pDX, IDC_EDIT_DIR_A, m_sDirectionA);
	DDX_Text(pDX, IDC_EDIT_DIR_B, m_sDirectionB);
	DDX_Text(pDX, IDC_EDIT_DIR_C, m_sDirectionC);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_A, m_sOutputA);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_B, m_sOutputB);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_C, m_sOutputC);
	DDX_Text(pDX, IDC_EDIT_INPUT_A, m_sInputA);
	DDX_Text(pDX, IDC_EDIT_INPUT_B, m_sInputB);
	DDX_Text(pDX, IDC_EDIT_INPUT_C, m_sInputC);
	DDX_Text(pDX, IDC_EDIT_START_ADDR, m_iStartAddress);
	DDX_Text(pDX, IDC_EDIT_STN_MESSSAGE, m_sStnMessage);
	DDX_Text(pDX, IDC_STATIC_COMMAND, m_sCommand);
	DDX_Text(pDX, IDC_STATIC_REPLY, m_sReply);
	DDX_Check(pDX, IDC_CHECK1, m_bApplyCheckSum);
	DDX_Check(pDX, IDC_CHECK2, m_bNoReply);
	DDX_Text(pDX, IDC_EDIT_CH, m_iAdcCh);
	DDX_Text(pDX, IDC_EDIT_ADC, m_iAdcVal);
	DDX_CBIndex(pDX, IDC_COMBO_ADC_CH, m_iAdcCh);
}

BEGIN_MESSAGE_MAP(CUSBPIO24TestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_SETDIR_A, &CUSBPIO24TestDlg::OnBnClickedSetdirA)
	ON_BN_CLICKED(IDC_SETDIR_B, &CUSBPIO24TestDlg::OnBnClickedSetdirB)
	ON_BN_CLICKED(IDC_SETDIR_C, &CUSBPIO24TestDlg::OnBnClickedSetdirC)
	ON_BN_CLICKED(IDC_OUTPUT_A, &CUSBPIO24TestDlg::OnBnClickedOutputA)
	ON_BN_CLICKED(IDC_OUTPUT_B, &CUSBPIO24TestDlg::OnBnClickedOutputB)
	ON_BN_CLICKED(IDC_OUTPUT_C, &CUSBPIO24TestDlg::OnBnClickedOutputC)
	ON_BN_CLICKED(IDC_INPUT_A, &CUSBPIO24TestDlg::OnBnClickedInputA)
	ON_BN_CLICKED(IDC_INPUT_B, &CUSBPIO24TestDlg::OnBnClickedInputB)
	ON_BN_CLICKED(IDC_INPUT_C, &CUSBPIO24TestDlg::OnBnClickedInputC)
	ON_BN_CLICKED(IDC_SEND_STRING, &CUSBPIO24TestDlg::OnBnClickedSendString)
	ON_BN_CLICKED(IDC_RADIO_MODE1, &CUSBPIO24TestDlg::OnBnClickedRadioMode1)
	ON_BN_CLICKED(IDC_RADIO_MODE2, &CUSBPIO24TestDlg::OnBnClickedRadioMode2)
	ON_BN_CLICKED(IDC_RADIO_MODE3, &CUSBPIO24TestDlg::OnBnClickedRadioMode3)
	ON_BN_CLICKED(IDC_CHECK1, &CUSBPIO24TestDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK2, &CUSBPIO24TestDlg::OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_INPUT_ADC, &CUSBPIO24TestDlg::OnBnClickedInputAdc)
	ON_CBN_SELCHANGE(IDC_COMBO_BOARD_NO, &CUSBPIO24TestDlg::OnCbnSelchangeComboBoardNo)
END_MESSAGE_MAP()


// CUSBPIO24TestDlg bZ[W nh

//----------------------------------------------------------------------------------------
//
//		Message:		WM_INITDIALOG
//
//		Desc:		_CAȌ
//
//----------------------------------------------------------------------------------------
BOOL CUSBPIO24TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

/*---------------------------------------------------------------
	CComboBox* cmb = (CComboBox*)GetDlgItem( IDC_COMBO_BOARD_NO );
	cmb->AddString( "0" );
	cmb->AddString( "1" );
	cmb->AddString( "2" );
	cmb->AddString( "3" );
	cmb->AddString( "4" );
	cmb->AddString( "5" );
	cmb->AddString( "6" );
	cmb->AddString( "7" );
---------------------------------------------------------------*/

	CComboBox* cmb = (CComboBox*)GetDlgItem( IDC_COMBO_ADC_CH );
	cmb->AddString( "0" );
	cmb->AddString( "1" );
	cmb->AddString( "2" );
	cmb->AddString( "3" );
	cmb->AddString( "4" );
	cmb->AddString( "5" );
	cmb->AddString( "6" );
	cmb->AddString( "7" );
	
	SetData();
	gMchUSB.Initialize();


	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CUSBPIO24TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

//----------------------------------------------------------------------------------------
//
//		Message:		WM_CLOSE
//
//		Desc:		I
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnClose()
{
	gMchUSB.Close( 0 );
}



//----------------------------------------------------------------------------------------
//
//		Message:		WM_PAINT
//
//		Desc:		`揈
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CUSBPIO24TestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



//----------------------------------------------------------------------------------------
//
//		Function:	SetData
//
//		Desc:		ݒ̃pl\
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::SetData()
{
	bool	enable;

	enable = ( m_iMode == _MODE_ADC || m_iMode == _MODE_STN )? false: true;
	GetDlgItem( IDC_STATIC_DIR_A )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_DIR_A )->EnableWindow( enable );
	GetDlgItem( IDC_SETDIR_A )->EnableWindow( enable );
	GetDlgItem( IDC_STATIC_IO_A )->EnableWindow( enable );
	GetDlgItem( IDC_OUTPUT_A )->EnableWindow( enable );
	GetDlgItem( IDC_INPUT_A )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_INPUT_A )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_OUTPUT_A )->EnableWindow( enable );

	enable = ( m_iMode == _MODE_ADC && m_iBoardNo < 8 )? true: false;
	GetDlgItem( IDC_STATIC_ADC )->EnableWindow( enable );
	GetDlgItem( IDC_STATIC_CH )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_CH )->EnableWindow( enable );
	GetDlgItem( IDC_INPUT_ADC )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_ADC )->EnableWindow( enable );

	enable = ( m_iMode == _MODE_STN )? true: false;
	GetDlgItem( IDC_STATIC_STN )->EnableWindow( enable );
	GetDlgItem( IDC_STATIC_START )->EnableWindow( enable );
	GetDlgItem( IDC_STATIC_STRING )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_START_ADDR )->EnableWindow( enable );
	GetDlgItem( IDC_EDIT_STN_MESSSAGE )->EnableWindow( enable );
	GetDlgItem( IDC_SEND_STRING )->EnableWindow( enable );


	UpdateData( false );
}



//----------------------------------------------------------------------------------------
//
//		Function:	GetData
//
//		Desc:		pl\̐ݒ荞
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::GetData()
{
	UpdateData();




}


//----------------------------------------------------------------------------------------
//
//		Function:	SendCommand
//
//		Desc:		R}h̑o
//
//		In:			sCommand		R}h
//					bNeedReply		true: ҂A false: sv
//
//		Ret:		true: A false: s
//
//		Note:		̓}`oCgŃRpC邱
//					i@Wide Char ̏ꍇ͕ϊKv@j
//
//----------------------------------------------------------------------------------------
bool CUSBPIO24TestDlg::SendCommand( CString sCommand, bool bNeedReply )
{
	int		i, len, sum, maxretry;
	CString	s, s2;
	LPSTR	p;
	_TCHAR	recvbuf[128];

	if ( gMchUSB.IsOpen( 0 ) == false )
	{
		if ( gMchUSB.Open( 0 ) == false )
		{
			AfxMessageBox( "Open USB Error", MB_ICONSTOP | MB_OK );
			return	false;
		}
	}

	s = sCommand;
	len = s.GetLength();
	p = sCommand.GetBuffer(1);
	if ( m_bApplyCheckSum )
	{
		//	`FbNT
		sum = 0;
		for( i = 0; i < len; i++ )
		{
			sum += (int)*p++;
		}
		sum &= 0x00ff;
		s2.Format("%02X", sum );
		s += s2;
	}
	s += (char)0x0d;		// f~^
	m_sCommand = s;
	m_sReply = "";
	gMchUSB.Write( 0, (BYTE*)s.GetBuffer(1), s.GetLength());
	//
	//	TvvO̍\킩₷邽ߎM͕ʃXbh
	//	Ȃ킸Aő҂
	//
	if ( bNeedReply )
	{
		maxretry = 50;
		for( i = 0; i < maxretry; i++ )
		{	
			len = gMchUSB.Read( 0, (BYTE*)recvbuf, 128, 50 );
			if ( len > 0 )
				break;
			Sleep( 10 );
		}
		if ( i == maxretry )
		{
			//	Ȃ
			m_sReply = "( Time Out )";
			UpdateData( false );
			return	false;
		}else{
			// 퉞
			recvbuf[len] = 0;
			m_sReply = recvbuf;
		}
	}
	UpdateData( false );
	return	true;
}


//----------------------------------------------------------------------------------------
//
//		Command:	IDC_SETDIR_A, B, C
//
//		Desc:		|[g̐ݒ
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedSetdirA()
{
	SetDirection( 0 );
}

void CUSBPIO24TestDlg::OnBnClickedSetdirB()
{
	SetDirection( 1 );
}

void CUSBPIO24TestDlg::OnBnClickedSetdirC()
{
	SetDirection( 2 );
}



//----------------------------------------------------------------------------------------
//
//		Function:	SetDirection
//
//		Desc:		|[g̐ݒ
//
//		In:			nPort	0: Port-A, 1: Port-B, 2: Port-C
//
//		Format:		PDppvv	( pp:|[gԍA vv:lj	
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::SetDirection( int nPort )
{
	CString		s, s2, s3;

	UpdateData();

	s = "PD";
	s2.Format("%02X", nPort );
	s += s2;
	switch( nPort )
	{
		case 0:		s2 = m_sDirectionA;		break;
		case 1:		s2 = m_sDirectionB;		break;
		case 2:		s2 = m_sDirectionC;		break;
	}
	s3 = "00";
	s3 += s2;
	s2 = s3.Right(2);
	s2.MakeUpper();			// 啶
	s += s2;
	SendCommand( s, !m_bNoReply );
}



//----------------------------------------------------------------------------------------
//
//		Command:	IDC_OUTPUT_A, B, C
//
//		Desc:		|[go
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedOutputA()
{
	SetPort( 0 );
}

void CUSBPIO24TestDlg::OnBnClickedOutputB()
{
	SetPort( 1 );
}

void CUSBPIO24TestDlg::OnBnClickedOutputC()
{
	SetPort( 2 );
}


//----------------------------------------------------------------------------------------
//
//		Function:	SetPort
//
//		Desc:		|[go
//
//		Format:		POppvv   ( pp:|[gԍA vv:lj		
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::SetPort( int nPort )
{
	CString		s, s2;

	UpdateData();

	s = "PO";
	s2.Format("%02X", nPort );
	s += s2;

	switch( nPort )
	{
		case 0:		s2 = m_sOutputA.Right(2);		break;
		case 1:		s2 = m_sOutputB.Right(2);		break;
		case 2:		s2 = m_sOutputC.Right(2);		break;
	}
	s2.MakeUpper();		// 啶
	s += s2;
	SendCommand( s, !m_bNoReply );
}



//----------------------------------------------------------------------------------------
//
//		Command:	IDC_INPUT_A, B, C
//
//		Desc:		|[g
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedInputA()
{
	GetPort( 0 );
}

void CUSBPIO24TestDlg::OnBnClickedInputB()
{
	GetPort( 1 );
}

void CUSBPIO24TestDlg::OnBnClickedInputC()
{
	GetPort( 2 );
}

//----------------------------------------------------------------------------------------
//
//		Function:	GetPort
//
//		Desc:		|[g
//
//		Format:		In:		PIpp	
//					Out:	PIppvv  ( pp:|[gԍA vv:lj	
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::GetPort( int nPort )
{
	CString		s, s2;

	UpdateData();

	s = "PI";
	s2.Format("%02X", nPort );
	s += s2;
	if ( SendCommand( s, true ) == false )
	{
		m_sReply = "Timeout";
		UpdateData( false );
		return;
	}
	if ( m_sReply.GetLength() < 6 )
	{
		m_sReply = "Length Error";
		UpdateData( false );
		return;
	}
	s2 = m_sReply.Mid( 4, 2 );
	switch( nPort )
	{
		case 0:		m_sInputA = s2;		break;
		case 1:		m_sInputB = s2;		break;
		case 2:		m_sInputC = s2;		break;
	}
	UpdateData( false );

}


//----------------------------------------------------------------------------------------
//
//		Command:	IDC_SEND_STRING
//
//		Desc:		STN t֕񏑂
//
//		Format:		In:	LDrrccnnvvv...vv  
//					 ( rr:sAhXAcc:AhXA nn:A vvv:j	
//	
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedSendString()
{
	CString		s, s2;
	int		row, col, len;

	UpdateData();

	s = "LD";
	row = m_iStartAddress / 20;
	col = m_iStartAddress % 20;
	s2.Format("%02X", row );
	s += s2;
	s2.Format("%02X", col );
	s += s2;
	len = m_sStnMessage.GetLength();
	s2.Format("%02X", len );
	s += s2;
	s += m_sStnMessage;
	SendCommand( s, !m_bNoReply );

}



//----------------------------------------------------------------------------------------
//
//		Command:	IDC_RADIO_MODEx
//
//		Desc:		[hݒ{^
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedRadioMode1()
{
	UpdateData();
	SetData();
	SetMode();
}

void CUSBPIO24TestDlg::OnBnClickedRadioMode2()
{
	UpdateData();
	SetData();
	SetMode();
}

void CUSBPIO24TestDlg::OnBnClickedRadioMode3()
{
	UpdateData();
	SetData();
	SetMode();
}


//----------------------------------------------------------------------------------------
//
//		Command:	IDC_CHECKx
//
//		Desc:		[h̃IvV
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedCheck1()
{
	SetMode();
}


void CUSBPIO24TestDlg::OnBnClickedCheck2()
{
	SetMode();
}


//----------------------------------------------------------------------------------------
//
//		Command:	IDC_COMBO_BOARD_NO
//
//		Desc:		{[hԍ̕ύX
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnCbnSelchangeComboBoardNo()
{
	UpdateData();
	SetData();
}



//----------------------------------------------------------------------------------------
//
//		Function:	SetMode
//
//		Desc:		[h̐ݒR}h𑗂
//
//		Format:		MDmm		( mm:[hj	
//
//					mm: bit-7	CheckSum Mode
//						bit-6	NoReply Mode
//						bit-0,1 Mode
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::SetMode()
{
	CString		s, s2;
	int			mode;

	UpdateData();

	s = "MD";
	mode = m_iMode;
	if ( m_bApplyCheckSum )
		mode |= 0x80;
	if ( m_bNoReply )
		mode |= 0x40;

	s2.Format( "%02X", mode );
	s += s2;
	SendCommand( s, !m_bNoReply );

}



//----------------------------------------------------------------------------------------
//
//		Command:	IDC_INPUT_ADC
//
//		Desc:		A/D ϊ
//
//		Format:		In:		ADcc			
//					Out:	ADccvvvv ( cc:ADC`lԍA vvvv:lj	
//
//----------------------------------------------------------------------------------------
void CUSBPIO24TestDlg::OnBnClickedInputAdc()
{
	CString		s, s2;
	int		val;

	UpdateData();

	s = "AD";
	s2.Format("%02X", m_iAdcCh );
	s += s2;
	if ( SendCommand( s, true ) == false )
	{
		m_sReply = "Timeout";
		UpdateData( false );
		return;
	}
	if ( m_sReply.GetLength() < 8 )
	{
		m_sReply = "Length Error";
		UpdateData( false );
		return;
	}
	s2 = m_sReply.Mid( 4, 4 );
	sscanf_s( s2.GetBuffer(1), "%X", &val );
	m_iAdcVal = val;

	UpdateData( false );
}

