// USBPIO24TestDlg.h : wb_[ t@C
//

#pragma once




// CUSBPIO24TestDlg _CAO
class CUSBPIO24TestDlg : public CDialog
{
// RXgNV
public:
	CUSBPIO24TestDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_USBPIO24TEST_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	void SetData();
	void GetData();
	bool SendCommand( CString sCommand, bool bNeedReply );
	void SetMode();
	void SetDirection( int nPort );
	void SetPort( int nPort );
	void GetPort( int nPort );

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnClose();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

protected:

	int m_iBoardNo;					// {[hԍ
	int m_iMode;					// 샂[h
	CString m_sDirectionA;			// |[gݒ
	CString m_sDirectionB;
	CString m_sDirectionC;
	CString m_sOutputA;				// |[go͒l
	CString m_sOutputB;
	CString m_sOutputC;
	CString m_sInputA;				// |[g͒l
	CString m_sInputB;
	CString m_sInputC;
	int m_iStartAddress;			// tJnAhX
	CString m_sStnMessage;			// tM
	CString m_sCommand;				// USBPIO-24 R}h
	CString m_sReply;				// USBPIO-24 
	bool	m_bPortOpen;
	BOOL m_bApplyCheckSum;
	BOOL m_bNoReply;
	int m_iAdcVal;
	int m_iAdcCh;

public:
	afx_msg void OnBnClickedSetdirA();
	afx_msg void OnBnClickedSetdirB();
	afx_msg void OnBnClickedSetdirC();
	afx_msg void OnBnClickedOutputA();
	afx_msg void OnBnClickedOutputB();
	afx_msg void OnBnClickedOutputC();
	afx_msg void OnBnClickedInputA();
	afx_msg void OnBnClickedInputB();
	afx_msg void OnBnClickedInputC();
	afx_msg void OnBnClickedSendString();
	afx_msg void OnBnClickedRadioMode1();
	afx_msg void OnBnClickedRadioMode2();
	afx_msg void OnBnClickedRadioMode3();
	afx_msg void OnBnClickedCheck1();
	afx_msg void OnBnClickedCheck2();
	afx_msg void OnBnClickedInputAdc();

	afx_msg void OnCbnSelchangeComboBoardNo();
};
